Subject: Re: [PATCH 0/2] Let "git submodule add" fail when .git/modules/<name> already exists

From: Jens Lehmann <[email-masked]>
Date: Sun, 30 Sep 2012 21:19:59 +0200

Am 30.09.2012 06:47, schrieb Junio C Hamano:
> Jens Lehmann <[email-masked]> writes:
> 
>>> The only long term solution I can think of is to use some kind of UUID for
>>> the name, so that the names of newly added submodules won't have a chance
>>> to clash anymore. For the short term aborting "git submodule add" when a
>>> submodule of that name already exists in .git/modules of the superproject
>>> together with the ability to provide a custom name might at least solve
>>> the local clashes.
> 
> That assumes that the addition of the submodule for the second time
> is to add a completely different submodule at the same location and
> is done on purpose, but is that a sensible assumption?
> 
> If a superproject that is about an embedded appliance used to have a
> submodule A bound at its path "kernel", but for some reason stopped
> shipping with "kernel" and then later reintroduced the directory
> "kernel" bound to some submodule B, my gut feeling is that it is
> just as likely (if not more likely) that A and B are indeed the same
> submodule (i.e. it shares the same history) as they are totally
> unrelated.
> 
> Could it be that it is a user error combined with the immaturity of
> "git submodule" tool that does not yet support "it used to be here,
> but it disappears for a while and then it reappears in the history
> of the superproject" very well that caused the user to manually add
> a "new" submodule which in fact is the same submodule at the same
> path?
> 
> I think failing with a better error message is a good idea. It
> should suggest to either resurrect the submodule that is stashed
> away in "$GIT_DIR/modules/$name" if it indeed is the same, or to
> give it a different name (perhaps "kernel" used to be pointing at
> the Linux kernel history, then the user is replacing it with a
> totally different implementation that is really from different
> origin and do not share any history, perhaps BSD).  In such a case,
> the user may want to pick bsd-kernel or something as its name, to
> differentiate it.

Good point! I will add a more detailed error message (including
the url of the default remote which is configured for the already
present submodule repo) and teach --force to skip the test and
resurrect that submodule repo.

>> Using some kind of UUID can easily be added in a subsequent patch,...
> 
> I would suggest thinking really long and hard before saying UUID.

Absolutely.

> It is an easy cop-out to ensure uniqueness, but risks to allow two
> people (or one person at two different time) to give two unrelated
> names to a single thing that actually is the same.

I'm not too worried about that (even though it would be good for
the disk footprint). And I couldn't come up with a better way to
solve the problem we currently have when the same name is used
for two different submodule repos.

> A better alternative might be to use the commit object name at the
> root of the history of the submodule, which would catch the simplest
> and most common case of the mistake, I would think.

This won't work well e.g. when one uses a fork of another repo,
that will contain different commits while still having the same
root commit. I was also thinking about hashing the URL, but that
will break when the user reconfigures the URL to somewhere else.
After playing with some ideas I couldn't find a way to let the
submodule's repo provide sufficient uniqueness.

I'd say for now we go with the detection of name clashes and let
the user choose if he wants to resurrect that submodule repo or
if he wants to choose another name. But if we notice further down
the road that collisions are a problem in real life, we can think
again if UUIDs - or something else - might be a solution.